Imports System
Imports System.IO
Imports System.IO.Ports
Imports System.Threading
Imports System.Windows.Forms
Imports System.Management
Imports Microsoft.VisualBasic
Imports System.Drawing.Drawing2D
Imports ASCOM.Utilities
Imports ASCOM.Astrometry

Public Class FormMain

    Dim Ports As String() = SerialPort.GetPortNames
    Dim ComPort As String

    Public Const V As String = "Version 15.0"
    Public Const V_D As String = "2-May-2024"

    Dim Port As Integer
    Dim Port2 As Integer
    Dim Baud As Long
    Dim LastComPortRcv As Integer = 1
    Dim Download As Boolean
    Dim Download_1st_write As Boolean
    Dim Download_1st_read As Boolean
    Dim Download_1st_erase As Boolean
    Dim Download_count As Long
    Dim ComLast As Integer
    Dim Indata As String
    Dim Indata2 As String
    Dim LX200_command As String
    Dim Cmd2 As String
    Dim Outdata As String
    Dim InCount As Long
    Dim RespCount As Long
    Dim InBufLen As Integer
    Dim InBufLen2 As Integer
    Dim StartStop As Boolean
    Dim DataAscii As String
    Dim LX200_mode(3) As String
    Public LX200_dec As String
    Public LX200_ra As String
    Public LX200_alt As String
    Public LX200_az As String
    Dim LX200_currentdate As String
    Dim LX200_localtime As String
    Dim LX200_UTCoffset As String
    Public LX200_lat As String
    Public LX200_lon As String
    Dim LX200_sideraltime As String
    Dim LX200_tracking_rate As String
    Dim LX200_brighter_limit As String
    Dim LX200_fainter_limit As String
    Dim LX200_calendar_format As String
    Dim LX200_field_dia As String
    Dim LX200_high_limit As String
    Dim LX200_low_limit As String
    Dim LX200_larger_size_limit As String
    Dim LX200_smaller_size_limit As String
    Dim LX200_site1 As String
    Dim LX200_site2 As String
    Dim LX200_site3 As String
    Dim LX200_site4 As String
    Dim LX200_meridian_offset As String
    Dim PulseGuide1 As String = "30#"
    Dim PulseGuide2 As String = "90#"
    Dim PulseGuide3 As String = "225#"
    Dim PulseGuide4 As String = "115200#"
    Dim PulseGuide5 As String = "0#"
    Dim PulseGuide6 As String = "0#"
    Dim CP4ip As String = "0.0.0.0#"

    Dim ML1pos As String = "8000"
    Dim ML2pos As String = "8000"
    Dim ML1step As String = "FF"
    Dim ML2step As String = "FF"
    Dim ML1speed As String = "08"
    Dim ML2speed As String = "10"
    Dim ML1npos As String = "8500"
    Dim ML2npos As String = "7500"
    Dim ML1temp As String = "0030"
    Dim ML2temp As String = "0030"

    Dim AP_GTO_Text As String
    Public AP_SOP As String
    Public SiderealTime As String = ""
    Dim SiteLongitude As Double = -76.9258
    Dim AP_Long As Boolean
    Dim AP_Version As String
    Dim Beg As Integer
    Dim I As Integer
    Dim RespSent As Boolean = False
    Dim SerialPortNameList As New List(Of String)()

    Dim Autostar_Object As String
    Dim Autostar_Object_Top As String
    Dim Autostar_Sim As String

    Dim InputBoxText, OutputBoxText As String
    Dim ExitButtonPressed As Boolean = False

    Dim TimeSet As Boolean = False
    Dim DateSet As Boolean = False

    Dim SlewRD As Boolean = False
    Dim SlewAA As Boolean = False
    Dim Deg As Single
    Dim DegSign As String = ""
    Dim M As Double
    Dim S As Double
    Dim SS As Double
    Dim LAT As Double
    Dim LON As Double
    Dim Alt As Double
    Dim Az As Double
    Dim RA As Double
    Dim LST As Double
    Dim DEC As Double
    Dim ST As Double

    Dim utilities As Util ' Private variable to hold an ASCOM Utilities object
    Dim utl As New ASCOM.Utilities.Util

    Private Sub FormMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim I, J As Integer
        Dim S As String

        If My.Settings.NeedUpgrade = True Then
            My.Settings.Upgrade()
        End If

        Control.CheckForIllegalCrossThreadCalls = False
        AP_GTO_Text = LabelAPGTO.Text
        LabelAPGTO.Text = ""

        ' put verison in title
        Me.Text = Me.Text & " - " & V

        ' get all com ports with OK status and put at top of com combo box
        GetComPorts()
        For I = 0 To SerialPortNameList.Count - 1
            ComboBoxCom.Items.Add(SerialPortNameList(I))
            ComboBoxCom2.Items.Add(SerialPortNameList(I))
        Next

        ComboBoxCom.Items.Add("_____")
        ComboBoxCom2.Items.Add("None")
        ' put all possible com ports below found com ports
        For I = 1 To 255
            ComboBoxCom.Items.Add("COM" & I)
            ComboBoxCom2.Items.Add("COM" & I)
        Next
        ComboBoxCom.DropDownWidth = GetLongestItemWidth(ComboBoxCom)
        ComboBoxCom2.DropDownWidth = GetLongestItemWidth(ComboBoxCom2)

        '' populate found com port names combo box
        'Ports = SerialPort.GetPortNames
        'For Each ComPort In Ports
        '    ComboBoxCom.Items.Add(ComPort)
        'Next
        'ComboBoxCom.Items.Add("-")
        'J = ComboBoxCom.Items.Count
        '' put all possible com ports below found com ports
        'For I = 1 To 255
        '    ComboBoxCom.Items.Add("COM" & I)
        'Next

        ' set saved com port
        S = My.Settings.ComPort
        For I = 0 To ComboBoxCom.Items.Count - 1
            If S = ComboBoxCom.Items(I) Then
                J = I
            End If
        Next
        ComboBoxCom.SelectedIndex = J

        ' set saved com port2
        S = My.Settings.ComPort2
        For I = 0 To ComboBoxCom2.Items.Count - 1
            If S = ComboBoxCom2.Items(I) Then
                J = I
            End If
        Next
        ComboBoxCom2.SelectedIndex = J

        ' set lx200 baud
        ComboBoxLX200baud.SelectedIndex = My.Settings.LX200baud

        ' set lx200 mode
        ComboBoxLX200mode.SelectedIndex = My.Settings.LX200mode

        ' set lx200 firmware
        TextBoxLX200firmware.Text = My.Settings.LX200firmware

        ' set ap gtocp version
        TextBoxGTOCPfirmware.Text = UCase(My.Settings.APversion)

        ' set ap fixed sidereal time
        CheckBoxFSD.Checked = My.Settings.FixedSiderealTime
        TextBoxFSD.Text = My.Settings.FixedSiderealTimeValue
        Dim S1 As String = TextBoxFSD.Text
        ST = Mid(S1, 1, 2) + Mid(S1, 4, 2) / 60 + Mid(S1, 7, 2) / 3600 + Mid(S1, 10, 1) / 36000

        ' set command response dealy in ms
        NumUpDownRespDelay.Value = My.Settings.RespDelay

        ' set AGF Dome Controller emulator
        CheckBoxAGF.Checked = My.Settings.AGFdomeEm
        If CheckBoxAGF.Checked = True Then
            LabelAGF.Visible = True
        End If

        ' set Com Port2 used as AGF Dome Control
        CheckBoxComPort2AGF.Checked = My.Settings.ComPort2AGF

        ' set MooonLite stepper motor emulator
        CheckBoxML.Checked = My.Settings.MLfocusEm
        If CheckBoxML.Checked = True Then
            LabelML.Visible = True
        End If

        ' get input and output group headers
        InputBoxText = GroupBoxInput.Text & " = "
        OutputBoxText = GroupBoxOutput.Text & " = "

        ' init data
        LX200_mode(1) = "A"
        LX200_mode(2) = "L"
        LX200_mode(3) = "P"
        Autostar_Object_Top = " Select Item:     Object         #"
        Autostar_Sim = " Simulated        Astro          #"
        Autostar_Object = Autostar_Object_Top
        Download = False
        AP_Long = My.Settings.APlong
        CheckBoxAP_Long.Checked = AP_Long

        ' auto update Alt/Az on Ra/Dec slew
        CheckBoxAutoAlAz.Checked = My.Settings.AltAzAuto

        ' side of pier
        If My.Settings.PierSide <> "East" Or My.Settings.PierSide <> "West" Then
            My.Settings.PierSide = "Auto"
        End If
        If My.Settings.PierSide = "West" Then
            AP_SOP = "West"
            FormShow.RadioButtonWest.Checked = True
        End If
        If My.Settings.PierSide = "East" Then
            AP_SOP = "East"
            FormShow.RadioButtonEast.Checked = True
        End If
        If My.Settings.PierSide = "Auto" Then
            FormShow.RadioButtonAuto.Checked = True
        End If


        'LX200_dec = "+16*30:34#"
        'LX200_ra = "04:35:55#"
        'LX200_alt = "+51*48'00#"
        'LX200_az = "+114*48'00#"
        LX200_dec = My.Settings.DEC
        LX200_ra = My.Settings.RA
        LX200_alt = My.Settings.AL
        LX200_az = My.Settings.AZ
        LX200_currentdate = "2/18/21#"
        LX200_localtime = "9:15:30#"
        LX200_UTCoffset = "+04#"
        LX200_lat = My.Settings.LAT
        LX200_lon = My.Settings.LON
        LX200_tracking_rate = "60.0#"
        LX200_brighter_limit = "-01.0#"
        LX200_fainter_limit = "+12.0#"
        LX200_calendar_format = "24#"
        LX200_field_dia = "100#"
        LX200_high_limit = "90*#"
        LX200_low_limit = "+00#"
        LX200_larger_size_limit = "300'#"
        LX200_smaller_size_limit = "020'#"
        LX200_site1 = "Emulator site 1"
        LX200_site2 = "Emulator site 2"
        LX200_site3 = "Emulator site 3"
        LX200_site4 = "Emulator site 4"
        LX200_meridian_offset = "00:00:00.0#"

        If CheckBoxFSD.Checked = False Then
            GetSiderealTime()
        End If

        ' clear status line
        StatusLabel.Text = ""

    End Sub

    Private Sub ButtonExit_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonExit.Click
        Dim S As String = ""

        S = MessageBox.Show("Save settings?", "APGOT & LX200 Emulator", _
              MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question)
        Select Case S
            Case vbYes
                SaveSettings()
                ' exit program
                If SerialPort1.IsOpen = True Then SerialPort1.Close()
                If SerialPort2.IsOpen = True Then SerialPort2.Close()
                ExitButtonPressed = True
                Application.Exit()

            Case vbNo
                If SerialPort1.IsOpen = True Then SerialPort1.Close()
                If SerialPort2.IsOpen = True Then SerialPort2.Close()
                ExitButtonPressed = True
                Application.Exit()

            Case vbCancel
        End Select
    End Sub

    Private Sub FormMain_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If ExitButtonPressed = False Then
            SaveSettings()
        End If

    End Sub

    Private Sub SaveSettings()
        My.Settings.ComPort = ComboBoxCom.Items(ComboBoxCom.SelectedIndex)
        My.Settings.ComPort2 = ComboBoxCom2.Items(ComboBoxCom2.SelectedIndex)
        My.Settings.APversion = UCase(TextBoxGTOCPfirmware.Text)
        My.Settings.LX200firmware = TextBoxLX200firmware.Text
        My.Settings.FixedSiderealTime = CheckBoxFSD.Checked
        My.Settings.FixedSiderealTimeValue = TextBoxFSD.Text
        My.Settings.DEC = LX200_dec
        My.Settings.RA = LX200_ra
        My.Settings.AL = LX200_alt
        My.Settings.AZ = LX200_az
        My.Settings.LAT = LX200_lat
        My.Settings.LON = LX200_lon
        My.Settings.RespDelay = NumUpDownRespDelay.Value
        My.Settings.AGFdomeEm = CheckBoxAGF.Checked
        My.Settings.MLfocusEm = CheckBoxML.Checked
        My.Settings.ComPort2AGF = CheckBoxComPort2AGF.Checked
        My.Settings.APlong = AP_Long
        My.Settings.AltAzAuto = CheckBoxAutoAlAz.Checked
        My.Settings.NeedUpgrade = False
        If AP_SOP = "West" Then
            My.Settings.PierSide = True
        Else
            My.Settings.PierSide = False
        End If
        My.Settings.Save()

    End Sub

    Private Sub ButtonConnect_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonConnect.Click
        Dim ComPort As String
        Dim ComPort2 As String

        ComPort = Trim(Microsoft.VisualBasic.Left(ComboBoxCom.Items(ComboBoxCom.SelectedIndex), 6))
        ComPort2 = Trim(Microsoft.VisualBasic.Left(ComboBoxCom2.Items(ComboBoxCom2.SelectedIndex), 6))
        If SerialPort1.IsOpen = False Then
            SerialPort1.PortName = ComPort
            SerialPort1.BaudRate = Baud
            SerialPort2.PortName = ComPort2
            SerialPort2.BaudRate = Baud
            StatusLabel.Text = "Opening " & SerialPort1.PortName
            Application.DoEvents()
            On Error GoTo Open_Error
            Indata = ""
            SerialPort1.Open()
            If ComPort2 <> "None" Then
                Indata2 = ""
                StatusLabel.Text = "Opening " & SerialPort1.PortName & ", " & SerialPort2.PortName
                SerialPort2.Open()
                TimerCheckBuffer2.Enabled = True
            End If
            ButtonConnect.Text = "Stop"
            ButtonSend.Enabled = True
            TimerCheckBuffer.Enabled = True
            If SerialPort2.IsOpen = False Then
                StatusLabel.Text = "Connected " & SerialPort1.PortName
            Else
                StatusLabel.Text = "Connected " & SerialPort1.PortName & ", " & SerialPort2.PortName
            End If
        Else
            TimerCheckBuffer.Enabled = False
            StatusLabel.Text = "Closing " & SerialPort1.PortName
            Application.DoEvents()
            On Error GoTo Open_Error

            SerialPort1.Close()
            If SerialPort2.IsOpen = True Then
                TimerCheckBuffer2.Enabled = False
                SerialPort2.Close()
            End If
            ButtonSend.Enabled = False
            ButtonConnect.Text = "Start"
            StatusLabel.Text = "Disconnected " & SerialPort1.PortName & ", " & SerialPort2.PortName
            If Download = True Then
                StatusLabel.Text = "Download aborted"
                Download = False
            End If
            AP_Long = False
            CheckBoxAP_Long.Checked = AP_Long
            LabelAPGTO.Text = ""
        End If

        Exit Sub

Open_Error:
        StatusLabel.Text = Err.Description

    End Sub


    Private Sub ComboBoxLX200baud_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ComboBoxLX200baud.SelectedIndexChanged
        Baud = ComboBoxLX200baud.Items(ComboBoxLX200baud.SelectedIndex)

    End Sub

    Private Sub ButtonHexClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonHexClear.Click
        LX200_command = ""
        TextBoxCommand.Text = ""

    End Sub

    Private Sub ButtonHex_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonHex.Click
        Dim C, I As Integer
        Dim DataHex As String

        If TextBoxCommand.Text = "" Then Exit Sub
        If DataAscii <> "" Then
            TextBoxCommand.Text = DataAscii
            DataAscii = ""
            ButtonHex.Text = "Hex"
            ToolTip1.SetToolTip(ButtonHex, "Convert to hex")
        Else
            DataAscii = TextBoxCommand.Text
            DataHex = "Hex: "
            For I = 1 To Len(DataAscii)
                C = Asc(Mid(DataAscii, I, 1))
                DataHex = DataHex & Hex(C) & " "
            Next I
            TextBoxCommand.Text = DataHex
            ButtonHex.Text = "Ascii"
            ToolTip1.SetToolTip(ButtonHex, "Convert to ascii")
        End If

    End Sub

    Private Sub SerialPort1_DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort1.DataReceived
        InBufLen = SerialPort1.BytesToRead
        StatusLabel.Text = "DataReceived " & InBufLen
        Indata = Indata & SerialPort1.ReadExisting

    End Sub

    Private Sub SerialPort2_DataReceived(ByVal sender As Object, ByVal e As System.IO.Ports.SerialDataReceivedEventArgs) Handles SerialPort2.DataReceived
        InBufLen2 = SerialPort2.BytesToRead
        StatusLabel.Text = "DataReceived2 " & InBufLen2
        Indata2 = Indata2 & SerialPort2.ReadExisting

    End Sub

    Private Sub LX200_Send()
        If CheckBoxNoOutput.Checked = False Then
            ' output command and show input / response
            If NumUpDownRespDelay.Value > 0 Then
                Thread.Sleep(NumUpDownRespDelay.Value)
            End If
            Select Case LastComPortRcv
                Case 1
                    ListBoxInput.Items.Add(LX200_command)
                    ListBoxInput.SelectedIndex = InCount
                    SerialPort1.Write(Outdata)
                    ListBoxOutput.Items.Add(Outdata)
                Case 2
                    ListBoxInput.Items.Add("(2) " & LX200_command)
                    ListBoxInput.SelectedIndex = InCount
                    SerialPort2.Write(Outdata)
                    ListBoxOutput.Items.Add("(2) " & Outdata)
            End Select
            ScrollListBox(1)
            LX200_command = ""
            RespSent = True
        End If

    End Sub

    Private Sub ScrollListBox(ByVal Cnt As Integer)
        InCount = InCount + Cnt
        GroupBoxInput.Text = InputBoxText & InCount
        RespCount = RespCount + Cnt
        ListBoxInput.SelectedIndex = InCount - 1
        ListBoxOutput.SelectedIndex = RespCount - 1
        GroupBoxOutput.Text = OutputBoxText & RespCount

    End Sub

    Private Sub Remove_Space()
        ' remove space from commands sent from Megastar
        If Mid(LX200_command, Beg + 3, 1) = " " Then
            I = 4
        End If

    End Sub

    Private Sub ButtonAbout_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonAbout.Click
        FormAbout.Show()

    End Sub
    Private Sub GetComPorts()
        Dim I, J As Integer

        ' get all com ports with OK status
        Try
            Dim moSearch As New Management.ManagementObjectSearcher("root\CIMV2", "SELECT * FROM Win32_PnPEntity")
            Dim moCollect As Management.ManagementObjectCollection = moSearch.Get()
            Dim SerialPortName As String
            For Each moObject As Management.ManagementObject In moCollect
                SerialPortName = moObject.GetPropertyValue("Name")
                I = InStr(SerialPortName, "(COM")
                If moObject.GetPropertyValue("Status") <> "OK" Then
                    I = 0
                End If
                If I > 0 Then
                    J = InStr(SerialPortName, ")")
                    SerialPortNameList.Add(Mid(SerialPortName, I + 1, J - I - 1) & "     " & Mid(SerialPortName, 1, I - 2))
                End If
            Next
            SerialPortNameList.Sort()
        Catch ex As Exception
            StatusLabel.Text = ex.Message
        End Try

    End Sub

    Private Function GetLongestItemWidth(ByVal combo As ComboBox) As Integer
        Dim longest As Integer
        Dim str As String
        Dim g As Graphics = Graphics.FromImage(New Bitmap(1, 1))

        'Enumerate the items in the combo
        For Each str In combo.Items
            Dim wid As Integer

            'Get the width of the item; if it's longer than the
            'longest one so far, store it.
            wid = g.MeasureString(str, combo.Font).Width
            If wid > longest Then longest = wid
        Next
        If combo.Items.Count > combo.MaxDropDownItems Then
            longest = longest + SystemInformation.VerticalScrollBarWidth
        End If

        Return longest
    End Function

    Private Sub ButtonClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonClear.Click
        ListBoxInput.Items.Clear()
        ListBoxOutput.Items.Clear()
        InCount = 0
        RespCount = 0
        GroupBoxInput.Text = InputBoxText & InCount
        GroupBoxOutput.Text = OutputBoxText & RespCount
        TimeSet = False
        DateSet = False

    End Sub

    Private Sub ButtonReal_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ButtonReal.Click
        LX200_ra = "14:06:11.0#"
        LX200_dec = "+11*00:00#"
        LX200_alt = "+62*38:47#"
        LX200_az = "+181*07:59#"
        LX200_lat = "+38*55:33#"
        LX200_lon = "+076*55:33#"
        TextBoxFSD.Text = "14:07:53.0"
        StatusLabel.Text = "Real values set"

    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        FormShow.MaskedTextBoxRA.Text = Mid(LX200_ra, 1, LX200_ra.Length - 1)
        FormShow.MaskedTextBoxDEC.Text = Mid(LX200_dec, 1, LX200_dec.Length - 1)
        FormShow.MaskedTextBoxALT.Text = Mid(LX200_alt, 1, LX200_alt.Length - 1)
        FormShow.MaskedTextBoxLat.Text = Mid(LX200_lat, 1, LX200_lat.Length - 1)
        FormShow.MaskedTextBoxLon.Text = Mid(LX200_lon, 1, LX200_lon.Length - 1)
        If LX200_az.Length < 11 Then
            FormShow.MaskedTextBoxAZ.Text = "+0" & Mid(LX200_az, 2, LX200_az.Length - 2)
        Else
            FormShow.MaskedTextBoxAZ.Text = Mid(LX200_az, 1, LX200_az.Length - 1)
        End If
        FormShow.MaskedTextBoxSD.Text = TextBoxFSD.Text
        If AP_SOP = "East" Then
            FormShow.RadioButtonEast.Checked = True
        Else
            FormShow.RadioButtonEast.Checked = False
        End If
        FormShow.Show()

    End Sub

    Private Sub TimerCheckBuffer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TimerCheckBuffer.Tick
        If InBufLen >= 0 Then
            LastComPortRcv = 1
            CheckBuffer()
        End If

    End Sub

    Private Sub TimerCheckBuffer2_Tick(sender As System.Object, e As System.EventArgs) Handles TimerCheckBuffer2.Tick
        If InBufLen2 >= 0 Then
            Dim InDataSave As String = Indata
            Dim InBufLenSave As Integer = InBufLen
            Indata = Indata2
            InBufLen = InBufLen2
            LastComPortRcv = 2
            CheckBuffer()
            Indata2 = Indata
            InBufLen2 = Indata2.Length
            Indata = InDataSave
            InBufLen = InBufLenSave
        End If

    End Sub

    Private Sub CheckBuffer()
        Dim L As Integer
        Dim C, S As String
        Dim Autostar_Cmd As String
        Dim Rh, Rm, Rs, D, Dd, Dm, Ds As Integer
        Dim DecLong As Long
        Dim Dsign, Rss As String
        Dim DataRec() As String
        Dim U, B As Integer
        Dim PartCmd As String = ""

        If Indata.Length = 0 Then
            Exit Sub
        End If

        ' ACK LX200
        If Indata = Chr(6) Then
            Outdata = LX200_mode(ComboBoxLX200mode.SelectedIndex + 1)
            LX200_command = "<ACK>"
            LX200_Send()
            Indata = ""
        End If

        ' SkySafari connecting
        If Mid(Indata, 1, 3) = "$$$" Then
            LX200_command = "$$$ SkySafari"
            Outdata = "<none>"
            LX200_Send()
            Indata = Mid(Indata, 4, Indata.Length - 3)
        End If

        ' Split commands into array
        DataRec = Split(Indata, "#")
        U = UBound(DataRec)

        ' check for complete command at end of buffer
        If Microsoft.VisualBasic.Right(Indata, 1) <> "#" Then
            PartCmd = DataRec(U)
            U = U - 1
        End If

        ' Process commands
        If U > 0 Then
            For B = 0 To U

                ' Build command string
                LX200_command = DataRec(B)
                If Microsoft.VisualBasic.Left(LX200_command, 1) = ":" Then
                    LX200_command = LX200_command & "#"
                End If

                Beg = 1
                RespSent = False

                REM Downloading commands
                If Download = True Then
                    If Microsoft.VisualBasic.Left(LX200_command, 1) = Chr(6) Then
                        Outdata = "D"
                        LX200_command = " <ACK>"

                    End If
                    Outdata = "Y"

                    If Microsoft.VisualBasic.Left(LX200_command, 1) = "I" Then
                        LX200_command = " <Initialize>"
                        LX200_Send()
                        Download = False
                        StatusLabel.Text = ""
                    End If

                    If Microsoft.VisualBasic.Left(LX200_command, 1) = "E" Then
                        If Download_1st_erase = True Then
                            LX200_command = " <Erase>"
                            LX200_Send()
                        Else
                            SerialPort1.Write(Outdata)
                            LX200_command = ""
                        End If
                        Download_1st_erase = False
                    End If

                    If Microsoft.VisualBasic.Left(LX200_command, 1) = "W" Then
                        If Download_1st_write = True Then
                            LX200_command = " <Write>"
                            LX200_Send()
                            StatusLabel.Text = "Downloading"
                        Else
                            SerialPort1.Write(Outdata)
                            Download_count = Download_count + 1
                            If Download_count = 100 Then
                                StatusLabel.Text = "Downloading ."
                            End If
                            If Download_count = 200 Then
                                StatusLabel.Text = "Downloading .."
                            End If
                            If Download_count = 300 Then
                                StatusLabel.Text = "Downloading ..."
                                Download_count = 0
                            End If
                            LX200_command = ""
                        End If
                        Download_1st_write = False
                    End If

                    If Microsoft.VisualBasic.Left(LX200_command, 1) = "R" Then
                        If Download_1st_read = True Then
                            LX200_command = " <Read>"
                            LX200_Send()
                        Else
                            SerialPort1.Write(Outdata)
                            LX200_command = ""
                        End If
                        Download_1st_read = False
                    End If

                    Exit Sub
                End If

                REM Normal commands
                ' Begin Downloading of firmware
                If Microsoft.VisualBasic.Right(LX200_command, 1) = Chr(4) Then
                    Outdata = "Y"
                    LX200_command = "<Download>"
                    LX200_Send()
                    Download = True
                    Download_1st_write = True
                    Download_1st_read = True
                    Download_1st_erase = True
                    Download_count = 0
                    StatusLabel.Text = "Download"
                    Exit Sub
                End If

                'REM ASCOM sends this for Meade LX200R mounts not documented in Meade command manual
                If Microsoft.VisualBasic.Right(LX200_command, 5) = ":GVF#" Then
                    Outdata = "Version 4.2g#"
                    LX200_Send()
                End If


                REM MoonLite Dual Stepper Motors
                If CheckBoxML.Checked = True Then

                    REM Motor 1 commands
                    ' Current firmware version
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GV#" Then
                        Outdata = "01#"
                        LX200_Send()
                    End If
                    ' Current RED Led Backlight value, unsigned hex
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GB#" Then
                        Outdata = "A0#"
                        LX200_Send()
                    End If
                    ' Set motor speed
                    If Microsoft.VisualBasic.Left(LX200_command, 3) = ":SD" And _
                        Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                        ML1speed = Mid(LX200_command, 4, 2)
                    End If
                    ' Get motor speed
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GD#" Then
                        Outdata = ML1speed & "#"
                        LX200_Send()
                    End If
                    ' Set half step
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":SH#" Then
                        ML1step = "FF"
                    End If
                    ' Set full step
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":SF#" Then
                        ML1step = "00"
                    End If
                    ' Get step
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GH#" Then
                        Outdata = ML1step & "#"
                        LX200_Send()
                    End If
                    ' Get motor running
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GI#" Then
                        Outdata = "00#"
                        LX200_Send()
                    End If
                    ' Set motor current position
                    If Microsoft.VisualBasic.Left(LX200_command, 3) = ":SP" And _
                        Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                        ML1pos = Mid(LX200_command, 4, 4)
                    End If
                    ' Get motor current position
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GP#" Then
                        Outdata = ML1pos & "#"
                        LX200_Send()
                    End If
                    ' Set motor new position
                    If Microsoft.VisualBasic.Left(LX200_command, 3) = ":SN" And _
                        Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                        ML1npos = Mid(LX200_command, 4, 4)
                    End If
                    ' Get motor new position
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GN#" Then
                        Outdata = ML1npos & "#"
                        LX200_Send()
                    End If
                    ' Get current temperature
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GT#" Then
                        Outdata = ML1temp & "#"
                        LX200_Send()
                    End If
                    ' Move motor to new position
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":FG#" Then
                        ML1pos = ML1npos
                    End If

                    REM Motor 2 commands
                    ' Current firmware version
                    If Microsoft.VisualBasic.Right(LX200_command, 5) = ":2GV#" Then
                        Outdata = "01#"
                        LX200_Send()
                    End If
                    ' Current RED Led Backlight value, unsigned hex
                    If Microsoft.VisualBasic.Right(LX200_command, 5) = ":2GB#" Then
                        Outdata = "A0#"
                        LX200_Send()
                    End If
                    ' Set motor speed
                    If Microsoft.VisualBasic.Left(LX200_command, 4) = ":2SD" And _
                        Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                        ML2speed = Mid(LX200_command, 5, 2)
                    End If
                    ' Get motor speed
                    If Microsoft.VisualBasic.Right(LX200_command, 5) = ":2GD#" Then
                        Outdata = ML2speed & "#"
                        LX200_Send()
                    End If
                    ' Set half step
                    If Microsoft.VisualBasic.Right(LX200_command, 5) = ":2SH#" Then
                        ML2step = "FF"
                    End If
                    ' Set full step
                    If Microsoft.VisualBasic.Right(LX200_command, 5) = ":2SF#" Then
                        ML2step = "00"
                    End If
                    ' Get step
                    If Microsoft.VisualBasic.Right(LX200_command, 5) = ":2GH#" Then
                        Outdata = ML2step & "#"
                        LX200_Send()
                    End If
                    ' Get motor running
                    If Microsoft.VisualBasic.Right(LX200_command, 5) = ":2GI#" Then
                        Outdata = "00#"
                        LX200_Send()
                    End If
                    ' Set motor current position
                    If Microsoft.VisualBasic.Left(LX200_command, 4) = ":2SP" And _
                        Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                        ML2pos = Mid(LX200_command, 5, 4)
                    End If
                    ' Get motor current position
                    If Microsoft.VisualBasic.Right(LX200_command, 5) = ":2GP#" Then
                        Outdata = ML2pos & "#"
                        LX200_Send()
                    End If
                    ' Set motor new position
                    If Microsoft.VisualBasic.Left(LX200_command, 4) = ":2SN" And _
                        Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                        ML2npos = Mid(LX200_command, 5, 4)
                    End If
                    ' Get motor new position
                    If Microsoft.VisualBasic.Right(LX200_command, 5) = ":2GN#" Then
                        Outdata = ML2npos & "#"
                        LX200_Send()
                    End If
                    ' Get current temperature
                    If Microsoft.VisualBasic.Right(LX200_command, 5) = ":2GT#" Then
                        Outdata = ML2temp & "#"
                        LX200_Send()
                    End If
                    ' Move motor to new position
                    If Microsoft.VisualBasic.Right(LX200_command, 5) = ":2FG#" Then
                        ML2pos = ML2npos
                    End If

                End If


                REM AGF Dome Controller Commands
                If CheckBoxAGF.Checked = True Or (LastComPortRcv = 2 And CheckBoxComPort2AGF.Checked = True) Then
                    If Microsoft.VisualBasic.Right(LX200_command, 3) = ":I#" Then
                        Outdata = "AGF Dome Control v2.0  3-DEC-2019" & vbCr
                        LX200_Send()
                    End If

                    If Microsoft.VisualBasic.Right(LX200_command, 3) = ":V#" Then
                        Outdata = "AGF Dome Control v2.0  3-DEC-2019 Using Emulator Interface" & vbCr
                        LX200_Send()
                    End If

                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":D0#" Then
                        Outdata = "Debug Off" & vbCr
                        LX200_Send()
                    End If

                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":D1#" Then
                        Outdata = "Debug On" & vbCr
                        LX200_Send()
                    End If

                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":E1#" Then
                        Outdata = "Emulator mode On" & vbCr
                        LX200_Send()
                    End If

                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":E0#" Then
                        Outdata = "Emulator mode Off" & vbCr
                        LX200_Send()
                    End If

                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":Qe#" Then
                        Outdata = "Stop east" & vbCr
                        LX200_Send()
                    End If

                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":Qw#" Then
                        Outdata = "Stop west" & vbCr
                        LX200_Send()
                    End If

                    If Microsoft.VisualBasic.Right(LX200_command, 3) = ":Q#" Then
                        Outdata = "Stop all" & vbCr
                        LX200_Send()
                    End If

                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":Me#" Then
                        Outdata = "Guide east" & vbCr
                        LX200_Send()
                    End If

                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":Mw#" Then
                        Outdata = "Guide west" & vbCr
                        LX200_Send()
                    End If

                    If Microsoft.VisualBasic.Left(LX200_command, 3) = ":Te" And _
                        Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                        Dim MS As Integer = Mid(LX200_command, 4, 5)
                        Outdata = "Guide east " & Format(MS, "0 ms") & vbCr
                        LX200_Send()
                    End If

                    If Microsoft.VisualBasic.Left(LX200_command, 3) = ":Tw" And _
                        Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                        Dim MS As Integer = Mid(LX200_command, 4, 5)
                        Outdata = "Guide west " & Format(MS, "0 ms") & vbCr
                        LX200_Send()
                    End If

                    If Microsoft.VisualBasic.Left(LX200_command, 3) = ":Re" And _
                        Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                        Dim DG As Integer = Mid(LX200_command, 4, 3)
                        Outdata = "Rotate east " & Format(DG, "0 deg") & vbCr
                        LX200_Send()
                    End If

                    If Microsoft.VisualBasic.Left(LX200_command, 3) = ":Rw" And _
                        Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                        Dim DG As Integer = Mid(LX200_command, 4, 3)
                        Outdata = "Rotate west " & Format(DG, "0 deg") & vbCr
                        LX200_Send()
                    End If

                End If

                If CheckBoxML.Checked = False Then

                    REM Get Telescope Information commands
                    ' Get Altitude
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GA#" Then
                        Outdata = LX200_alt
                        LX200_Send()
                    End If

                    ' Get local telescope time
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":Ga#" Then
                        Outdata = LX200_localtime
                        LX200_Send()
                    End If

                    ' Get Browse brighter magnitude limit
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":Gb#" Then
                        Outdata = LX200_brighter_limit
                        LX200_Send()
                    End If

                    ' Get current date
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GC#" Then
                        If DateSet = False Then
                            Dim APdate As Date = Now
                            LX200_currentdate = APdate.Month & "/" & APdate.Day & "/" & Mid(APdate.Year, 3, 2)
                        End If
                        Outdata = LX200_currentdate & "#"
                        LX200_Send()
                    End If

                    ' Get calendar format
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":Gc#" Then
                        Outdata = LX200_calendar_format
                        LX200_Send()
                    End If

                    ' Get Dec of currently selected object, return dec of scope
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":Gd#" Then
                        Outdata = LX200_dec
                        LX200_Send()
                    End If

                    ' Get Ra & Dec
                    If Microsoft.VisualBasic.Right(LX200_command, 8) = ":GR#:GD#" Then
                        If AP_Long = True Then
                            If Len(LX200_ra) < 10 Then
                                Outdata = Mid(LX200_ra, 1, Len(LX200_ra) - 1) & ".0#"
                            Else
                                Outdata = LX200_ra
                            End If
                        Else
                            Outdata = LX200_ra
                        End If
                        LX200_Send()
                        Outdata = LX200_dec
                        LX200_Send()
                        If CheckBoxAutoAlAz.Checked = True Then
                            UpdateAltAz()
                        End If
                    End If

                    ' Get Dec
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GD#" Then
                        Outdata = LX200_dec
                        LX200_Send()
                        If CheckBoxAutoAlAz.Checked = True Then
                            UpdateAltAz()
                        End If
                    End If

                    ' Get find field diameter
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GF#" Then
                        Outdata = LX200_field_dia
                        LX200_Send()
                    End If

                    ' Get Browse fainter magnitude limit
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":Gf#" Then
                        Outdata = LX200_fainter_limit
                        LX200_Send()
                    End If

                    ' Get UTC offset time
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GG#" Then
                        Outdata = LX200_UTCoffset
                        LX200_Send()
                    End If

                    ' Get meridian offset
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GM#" Then
                        Outdata = LX200_meridian_offset
                        LX200_Send()
                    End If

                    ' Get Current Site Longitude
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":Gg#" Then
                        If AP_Long = True Then
                            If Mid(LX200_lon, 2, 1) = "0" Then
                                ' remove leading 0 on longitude, what AP mount will really send back"
                                Outdata = Mid(LX200_lon, 1, 1) & Mid(LX200_lon, 3, LX200_lon.Length - 1)
                            Else
                                Outdata = LX200_lon
                            End If
                        Else
                            Outdata = LX200_lon
                        End If
                        LX200_Send()
                    End If

                    ' Get high limit for object
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":Gh#" Then
                        Outdata = "+00#"
                        LX200_Send()
                    End If

                    ' Get Local Time
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GL#" Then
                        Dim APtime As Date = Now
                        If TimeSet = False Then
                            LX200_localtime = Format(APtime.Hour, "00") & ":" & _
                                Format(APtime.Minute, "00") & ":" & Format(APtime.Second, "00")
                        End If
                        If AP_Long = True Then
                            Outdata = LX200_localtime & "." & Mid(APtime.Millisecond, 1, 1) & "#"
                        Else
                            Outdata = LX200_localtime & "#"
                        End If
                        LX200_Send()
                    End If

                    ' Get larger size limit for BROWSE/FIND
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":Gl#" Then
                        Outdata = LX200_larger_size_limit
                        LX200_Send()
                    End If

                    ' Get site names
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GM#" Then
                        Outdata = LX200_site1
                        LX200_Send()
                    End If
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GN#" Then
                        Outdata = LX200_site2
                        LX200_Send()
                    End If
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GO#" Then
                        Outdata = LX200_site3
                        LX200_Send()
                    End If
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GP#" Then
                        Outdata = LX200_site4
                        LX200_Send()
                    End If

                    ' Get high limit for slew
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":Go#" Then
                        Outdata = LX200_high_limit
                        LX200_Send()
                    End If

                    ' Get minimum quality for find operation
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":Gq#" Then
                        Outdata = "GD#"
                        LX200_Send()
                    End If

                    ' Get Ra
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GR#" Then
                        If AP_Long = True Then
                            If Len(LX200_ra) < 10 Then
                                Outdata = Mid(LX200_ra, 1, Len(LX200_ra) - 1) & ".0#"
                            Else
                                Outdata = LX200_ra
                            End If
                        Else
                            Outdata = LX200_ra
                        End If
                        LX200_Send()
                        If CheckBoxAutoAlAz.Checked = True Then
                            UpdateAltAz()
                        End If
                    End If

                    ' Get Ra of currently selected object, return ra of scope
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":Gr#" Then
                        Outdata = LX200_ra
                        LX200_Send()
                    End If

                    ' Get Sidereal Time
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GS#" Then
                        If CheckBoxFSD.Checked = True Then
                            Outdata = TextBoxFSD.Text & "#"
                        Else
                            GetSiderealTime()
                            If AP_Long = True Then
                                Outdata = SiderealTime & "#"
                            Else
                                Outdata = Mid(SiderealTime, 1, 8) & "#"
                            End If
                        End If
                        LX200_Send()
                    End If

                    ' Get smaller size limit for BROWSE/FIND
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":Gs#" Then
                        Outdata = LX200_smaller_size_limit
                        LX200_Send()
                    End If

                    ' Get tracking rate
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GT#" Then
                        Outdata = LX200_tracking_rate
                        LX200_Send()
                    End If

                    ' Get Current Site Latitude
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":Gt#" Then
                        Outdata = LX200_lat
                        LX200_Send()
                    End If

                    ' Get Telescope Firmware Date
                    If Microsoft.VisualBasic.Right(LX200_command, 5) = ":GVD#" Then
                        Outdata = "May 17 2006#"
                        LX200_Send()
                    End If

                    ' Get Telescope Firmware Number
                    If Microsoft.VisualBasic.Right(LX200_command, 5) = ":GVN#" Then
                        Outdata = TextBoxLX200firmware.Text & "#"
                        LX200_Send()
                    End If

                    ' Get Telescope Product Name
                    If Microsoft.VisualBasic.Right(LX200_command, 5) = ":GVP#" Then
                        Outdata = "LX2001#"
                        LX200_Send()
                    End If

                    ' Get Telescope Firmware Time
                    If Microsoft.VisualBasic.Right(LX200_command, 5) = ":GVT#" Then
                        Outdata = "10:25:38#"
                        LX200_Send()
                    End If


                    ' Get Telescope status (added with firmware 4.1b)
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GW#" Then
                        If LX200_mode(ComboBoxLX200mode.SelectedIndex + 1) = "P" Then
                            S = "P"
                        Else
                            S = "A"
                        End If
                        Outdata = S & "T2"
                        LX200_Send()
                    End If

                    ' Get deepsky object search string
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":Gy#" Then
                        Outdata = "GPDCO#"
                        LX200_Send()
                    End If

                    ' Get OS used by INDI astroberry driver
                    If Microsoft.VisualBasic.Right(LX200_command, 5) = ":GOS#" Then
                        If Mid(TextBoxGTOCPfirmware.Text, 1, 4) = "VCP4" Then
                            Outdata = "099000261O000039#"
                        Else
                            Outdata = "029000220O000#"
                        End If
                        LX200_Send()
                    End If


                    ' Get Azimuth
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":GZ#" Then
                        Outdata = LX200_az
                        LX200_Send()
                    End If

                    REM Home Position commands
                    ' Query home status
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":h?#" Then
                        Outdata = "1"
                        LX200_Send()
                    End If

                    REM Movement commands
                    ' Slew to Target
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":MS#" Then
                        Outdata = "0"
                        LX200_Send()
                        If SlewRD = True And CheckBoxAutoAlAz.Checked = True Then
                            UpdateAltAz()
                        End If
                        If SlewAA = True And CheckBoxAutoAlAz.Checked = True Then
                            UpdateRaDec()
                        End If
                    End If

                    ' Move North
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":Mn#" Then
                        Dsign = Mid(LX200_dec, 1, 1)
                        Dd = Mid(LX200_dec, 2, 2)
                        Dm = Mid(LX200_dec, 5, 2)
                        Ds = Mid(LX200_dec, 8, 2)
                        DecLong = ((Dd * 3600) + (Dm * 60) + Ds)
                        If Mid(LX200_dec, 1, 1) = "+" Then
                            DecLong = DecLong + 5
                            Ds = DecLong - (Dd * 3600) - (Dm * 60)
                            If Ds > 59 Then
                                Ds = Ds - 60
                                Dm = Dm + 1
                            End If
                            Dm = (DecLong - (Dd * 3600) - Ds) / 60
                            If Dm > 59 Then
                                Dm = Dm - 60
                                Dd = Dd + 1
                            End If
                            Dd = (DecLong - (Dm * 60) - Ds) / 3600
                            If Dd > 89 Then
                                Dd = 89
                            End If
                        Else
                            DecLong = DecLong - 5
                            If DecLong < 0 Then
                                DecLong = DecLong * -1
                                Dsign = "+"
                            End If
                            Ds = DecLong - (Dd * 3600) - (Dm * 60)
                            If Ds < 0 Then
                                Ds = Ds + 60
                                Dm = Dm - 1
                            End If
                            Dm = (DecLong - (Dd * 3600) - Ds) / 60
                            If Dm < 0 Then
                                Dm = Dm + 60
                                Dd = Dd - 1
                            End If
                            Dd = (DecLong - (Dm * 60) - Ds) / 3600
                            If Dd < 0 Then
                                Dd = 0
                            End If
                        End If


                        LX200_dec = Dsign & Format(Dd, "00") & "*" & Format(Dm, "00") & ":" & Format(Ds, "00") & "#"
                    End If

                    ' Move South
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":Ms#" Then
                        Dsign = Mid(LX200_dec, 1, 1)
                        Dd = Mid(LX200_dec, 2, 2)
                        Dm = Mid(LX200_dec, 5, 2)
                        Ds = Mid(LX200_dec, 8, 2)
                        DecLong = ((Dd * 3600) + (Dm * 60) + Ds)
                        If Mid(LX200_dec, 1, 1) = "+" Then
                            DecLong = DecLong - 5
                            If DecLong < 0 Then
                                DecLong = DecLong * -1
                                Dsign = "-"
                            End If
                            Ds = DecLong - (Dd * 3600) - (Dm * 60)
                            If Ds < 0 Then
                                Ds = Ds + 60
                                Dm = Dm - 1
                            End If
                            Dm = (DecLong - (Dd * 3600) - Ds) / 60
                            If Dm < 0 Then
                                Dm = Dm + 60
                                Dd = Dd - 1
                            End If
                            Dd = (DecLong - (Dm * 60) - Ds) / 3600
                            If Dd < 0 Then
                                Dd = 0
                            End If
                        Else
                            DecLong = DecLong + 5
                            Ds = DecLong - (Dd * 3600) - (Dm * 60)
                            If Ds > 59 Then
                                Ds = Ds - 60
                                Dm = Dm + 1
                            End If
                            Dm = (DecLong - (Dd * 3600) - Ds) / 60
                            If Dm > 59 Then
                                Dm = Dm - 60
                                Dd = Dd + 1
                            End If
                            Dd = (DecLong - (Dm * 60) - Ds) / 3600
                            If Dd > 89 Then
                                Dd = 89
                            End If
                        End If

                        LX200_dec = Dsign & Format(Dd, "00") & "*" & Format(Dm, "00") & ":" & Format(Ds, "00") & "#"
                    End If


                    ' Move East
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":Me#" Then
                        Rh = Mid(LX200_ra, 1, 2)
                        Rm = Mid(LX200_ra, 4, 2)
                        Rs = Mid(LX200_ra, 7, 2)
                        If Len(LX200_ra) > 9 Then
                            Rss = Mid(LX200_ra, 9, 2)
                        Else
                            Rss = ""
                        End If
                        Rs = Rs + 5
                        If Rs > 59 Then
                            Rs = Rs - 60
                            Rm = Rm + 1
                            If Rm > 59 Then
                                Rm = Rm - 60
                                Rh = Rh + 1
                                If Rh > 23 Then
                                    Rh = Rh - 24
                                End If
                            End If
                        End If
                        LX200_ra = Format(Rh, "00") & ":" & Format(Rm, "00") & ":" & Format(Rs, "00") & Rss & "#"
                    End If

                    ' Move West
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":Mw#" Then
                        Rh = Mid(LX200_ra, 1, 2)
                        Rm = Mid(LX200_ra, 4, 2)
                        Rs = Mid(LX200_ra, 7, 2)
                        If Len(LX200_ra) > 9 Then
                            Rss = Mid(LX200_ra, 9, 2)
                        Else
                            Rss = ""
                        End If
                        Rs = Rs - 5
                        If Rs < 0 Then
                            Rs = Rs + 60
                            Rm = Rm - 1
                            If Rm < 0 Then
                                Rm = Rm + 60
                                Rh = Rh - 1
                                If Rh < 0 Then
                                    Rh = Rh + 24
                                End If
                            End If
                        End If
                        LX200_ra = Format(Rh, "00") & ":" & Format(Rm, "00") & ":" & Format(Rs, "00") & Rss & "#"
                    End If

                    REM Telescope Set commands
                    I = 3
                    ' Set meridian offset
                    If Mid(LX200_command, Beg, 3) = ":SM" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Remove_Space()
                            If Mid(LX200_command, Beg + I, 1) = "-" Then
                                LX200_meridian_offset = Mid(LX200_command, Beg + I, 12)
                            Else
                                LX200_meridian_offset = Mid(LX200_command, Beg + I, 11)
                            End If
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If

                    ' Goto Ra
                    If Mid(LX200_command, Beg, 3) = ":Sr" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Remove_Space()
                            LX200_ra = Mid(LX200_command, Beg + I)
                            LX200_ra = Mid(LX200_ra, 1, Len(LX200_ra) - 1) & "#"
                            Outdata = "1"
                            LX200_Send()
                            SlewRD = True
                            SlewAA = False
                        End If
                    End If

                    ' Goto Dec
                    If Mid(LX200_command, Beg, 3) = ":Sd" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Remove_Space()
                            LX200_dec = Mid(LX200_command, Beg + I, 9) & "#"
                            Outdata = "1"
                            LX200_Send()
                            SlewRD = True
                            SlewAA = False
                        End If
                    End If

                    ' Goto azimuth
                    If Mid(LX200_command, Beg, 3) = ":Sz" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Remove_Space()
                            If Mid(LX200_command, Beg + I, 1) = "0" Then
                                LX200_az = "+" & Mid(LX200_command, Beg + I + 1, LX200_command.Length - Beg - I)
                            Else
                                LX200_az = "+" & Mid(LX200_command, Beg + I, LX200_command.Length - Beg - I + 1)
                            End If
                            Outdata = "1"
                            LX200_Send()
                            SlewRD = False
                            SlewAA = True
                        End If
                    End If

                    ' Goto altitude
                    If Mid(LX200_command, Beg, 3) = ":Sa" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Remove_Space()
                            LX200_alt = Mid(LX200_command, Beg + I, 6) & "'00#"
                            Outdata = "1"
                            LX200_Send()
                            SlewRD = False
                            SlewAA = True
                        End If
                    End If

                    ' Set brighter limit
                    If Mid(LX200_command, Beg, 3) = ":Sb" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Remove_Space()
                            LX200_brighter_limit = Mid(LX200_command, Beg + I, 6)
                            Outdata = "0"
                            LX200_Send()
                        End If
                    End If

                    ' Set baud rate
                    If Mid(LX200_command, Beg, 3) = ":SB" Then
                        If Mid(LX200_command, Beg + 4, 1) = "#" Then
                            I = Mid(LX200_command, Beg + 3, 1)
                            If I < 10 Then
                                ComboBoxLX200baud.SelectedItem = I
                                Outdata = "1"
                                LX200_Send()
                                ButtonConnect.PerformClick()
                                ButtonConnect.PerformClick()
                            End If
                        End If
                    End If

                    ' Change handbox date
                    If Mid(LX200_command, Beg, 3) = ":SC" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Remove_Space()
                            LX200_currentdate = Mid(LX200_command, Beg + I, 9)
                            'Outdata = "1Updating Planetary Data#        #"
                            If AP_Long = True Then
                                Outdata = "                                #                                #"
                            Else
                                Outdata = "1#"
                            End If
                            LX200_Send()
                            DateSet = True
                        End If
                    End If

                    ' Set target object to the specified selenogtaphic latitude on the Moon
                    If Mid(LX200_command, Beg, 3) = ":SE" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If

                    ' Set target object to the specified selenogtaphic longitude on the Moon
                    If Mid(LX200_command, Beg, 3) = ":Se" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If

                    ' Set faint magnitude limit
                    If Mid(LX200_command, Beg, 3) = ":Sf" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Remove_Space()
                            LX200_fainter_limit = Mid(LX200_command, Beg + I, 6)
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If

                    ' Set FIELD/IDENITIFY field diameter
                    If Mid(LX200_command, Beg, 3) = ":SF" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Remove_Space()
                            LX200_field_dia = Mid(LX200_command, Beg + I, 4)
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If

                    ' Set site longitude
                    If Mid(LX200_command, Beg, 3) = ":Sg" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Remove_Space()
                            LX200_lon = Mid(LX200_command, Beg + I, 8)
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If

                    ' Set UTC offset
                    If Mid(LX200_command, Beg, 3) = ":SG" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Remove_Space()
                            LX200_UTCoffset = Mid(LX200_command, Beg + I, 3) & "#"
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If

                    ' Set minimum object elevation limit
                    If Mid(LX200_command, Beg, 3) = ":Sh" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If

                    ' Set size of the smallest object returned by FIND/BROWSE
                    If Mid(LX200_command, Beg, 3) = ":SI" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Remove_Space()
                            LX200_smaller_size_limit = Mid(LX200_command, Beg + I, 3) & "'#"
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If

                    ' Set local time
                    If Mid(LX200_command, Beg, 3) = ":SL" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Remove_Space()
                            LX200_localtime = Mid(LX200_command, Beg + I, 9)
                            Outdata = "1"
                            LX200_Send()
                            TimeSet = True
                        End If
                    End If

                    ' Set sites names
                    If Mid(LX200_command, Beg, 3) = ":SM" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            L = Len(LX200_command) - Beg - 2
                            LX200_site1 = Mid(LX200_command, Beg + I, L)
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If
                    If Mid(LX200_command, Beg, 3) = ":SN" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            L = Len(LX200_command) - Beg - 2
                            LX200_site2 = Mid(LX200_command, Beg + I, L)
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If
                    If Mid(LX200_command, Beg, 3) = ":SO" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            L = Len(LX200_command) - Beg - 2
                            LX200_site3 = Mid(LX200_command, Beg + I, L)
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If
                    If Mid(LX200_command, Beg, 3) = ":SP" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            L = Len(LX200_command) - Beg - 2
                            LX200_site4 = Mid(LX200_command, Beg + I, L)
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If

                    ' Set highest elevation to which the telescope will slew
                    If Mid(LX200_command, Beg, 3) = ":So" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Remove_Space()
                            LX200_high_limit = Mid(LX200_command, Beg + I, 4)
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If

                    ' Set size of the largest object returned by FIND/BROWSE
                    If Mid(LX200_command, Beg, 3) = ":Ss" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Remove_Space()
                            LX200_larger_size_limit = Mid(LX200_command, I + 3, 3) & "'#"
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If

                    ' Set local sideral time
                    If Mid(LX200_command, Beg, 3) = ":SS" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Remove_Space()
                            LX200_sideraltime = Mid(LX200_command, Beg + I, 9)
                            TextBoxFSD.Text = LX200_sideraltime
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If

                    ' Set latitude
                    If Mid(LX200_command, Beg, 3) = ":St" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Remove_Space()
                            LX200_lat = Mid(LX200_command, Beg + I, 7)
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If

                    ' Set current tracking rate
                    If Mid(LX200_command, Beg, 3) = ":ST" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Remove_Space()
                            LX200_tracking_rate = Mid(LX200_command, Beg + I, 5)
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If

                    ' Set maximum slew rate
                    If Mid(LX200_command, Beg, 3) = ":Sw" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If

                    ' Set object selecton string used by FIND/BROWSE
                    If Mid(LX200_command, Beg, 3) = ":Sy" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If

                    ' Set RA tracking rate
                    If Mid(LX200_command, Beg, 3) = ":RR" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If

                    ' Set DEC tracking rate
                    If Mid(LX200_command, Beg, 3) = ":RD" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If

                    REM Telescope GPS commands
                    ' Take GPS fix
                    If Mid(LX200_command, Beg, 4) = ":gT#" Then
                        Outdata = "1"
                        Thread.Sleep(5000)
                        LX200_Send()
                    End If

                    REM Sync control commands
                    ' Synchonize telescope with currently selected database object
                    ' Calibrate mount (Sync) for Astro-Physics GTO
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":CM#" Then
                        If AP_Long = True Then
                            Outdata = "Coordinates     matched.        #"
                        Else
                            Outdata = "M31 EX GAL MAG 3.5 SZ178.0'#"
                        End If
                        LX200_Send()
                    End If

                    ' Re-calibrate mount (Re-Cal) for Astro-Physics GTO
                    If Microsoft.VisualBasic.Right(LX200_command, 5) = ":CMR#" Then
                        Outdata = "Coordinates     matched.        #"
                        LX200_Send()
                    End If

                    REM Other commands used by Meade programs
                    ' Select deep sky library
                    If Mid(LX200_command, Beg, 3) = ":Lo" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            S = Mid(LX200_command, Beg + 3, 1)
                            On Error Resume Next
                            I = -1
                            I = S
                            If I > 0 And I < 5 Then
                                Outdata = "1"
                            Else
                                Outdata = "0"
                            End If
                            LX200_Send()
                        End If
                    End If

                    ' Select star catalog library
                    If Mid(LX200_command, Beg, 3) = ":Ls" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            S = Mid(LX200_command, Beg + 3, 1)
                            On Error Resume Next
                            I = -1
                            I = S
                            If I > 0 And I < 5 Then
                                Outdata = "1"
                            Else
                                Outdata = "2"
                            End If
                            LX200_Send()
                        End If
                    End If

                    ' Start telescope automatic alignment sequence
                    If Mid(LX200_command, Beg, 4) = ":Aa#" Then
                        Outdata = "1"
                        Thread.Sleep(5000)
                        LX200_Send()
                    End If

                    ' Autostar update program commands
                    If Mid(LX200_command, Beg, 3) = ":uC" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Outdata = "0#"
                            LX200_Send()
                        End If
                    End If
                    If Mid(LX200_command, Beg, 3) = ":uA" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Outdata = "00001#"
                            LX200_Send()
                        End If
                    End If
                    If Mid(LX200_command, Beg, 4) = ":uR0" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Outdata = "00020007D6080200#"
                            LX200_Send()
                        End If
                    End If
                    If Mid(LX200_command, Beg, 3) = ":uW" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Outdata = "1#"
                            LX200_Send()
                        End If
                    End If
                    If Mid(LX200_command, Beg, 3) = ":un" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Outdata = "1#"
                            LX200_Send()
                        End If
                    End If
                    If Mid(LX200_command, Beg, 3) = ":uD" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Outdata = "1#"
                            LX200_Send()
                        End If
                    End If
                    If Mid(LX200_command, Beg, 3) = ":uE" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Outdata = "1#"
                            LX200_Send()
                        End If
                    End If
                    If Mid(LX200_command, Beg, 3) = ":uF" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Outdata = "319161#"
                            LX200_Send()
                        End If
                    End If

                    ' Autostarctrl communications
                    If Mid(LX200_command, Beg, 4) = ":EQ " Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Autostar_Cmd = LX200_command
                            Outdata = ""
                            Select Case Autostar_Cmd
                                Case ":EQ 0#"
                                    Outdata = "3886 3918 Object#"
                                Case ":EQ 3918#"
                                    Outdata = "3934 3966 Solar System#"
                                Case ":EQ 3966#"
                                    Outdata = "3982 0 Mercury#"
                                Case ":EQ 3982#"
                                    Outdata = "4014 0 Venus#"
                                Case ":EQ 4014#"
                                    Outdata = "4030 0 Mars#"
                                Case ":EQ 4030#"
                                    Outdata = "4046 0 Jupiter#"
                                Case ":EQ 4046#"
                                    Outdata = "4062 0 Saturn#"
                                Case ":EQ 4062#"
                                    Outdata = "4078 0 Uranus#"
                                Case ":EQ 4078#"
                                    Outdata = "4094 0 Neptune#"
                                Case ":EQ 4094#"
                                    Outdata = "4110 0 Pluto#"
                                Case ":EQ 4110#"
                                    Outdata = "4126 4142 Moon#"
                                Case ":EQ 4142#"
                                    Outdata = "4158 0 Overview#"
                                Case ":EQ 4158#"
                                    Outdata = "4190 0 Landing Sites#"
                                Case ":EQ 4190#"
                                    Outdata = "4206 0 Craters#"
                                Case ":EQ 4206#"
                                    Outdata = "4222 0 Mountains#"
                                Case ":EQ 4222#"
                                    Outdata = "4174 0 Mare,Lakes...#"
                                Case ":EQ 4174#"
                                    Outdata = "4142 0 Valleys,Rillis..#"
                                Case ":EQ 4142#"
                                    Outdata = "4158 0 Overview#"
                                Case ":EQ 4126#"
                                    Outdata = "3998 4238 Asteroids#"
                                Case ":EQ 4238#"
                                    Outdata = "4254 0 Select#"
                                Case ":EQ 4254#"
                                    Outdata = "4286 0 Add#"
                                Case ":EQ 4286#"
                                    Outdata = "4270 0 Delete#"
                                Case ":EQ 4270#"
                                    Outdata = "4238 0 Edit#"
                                Case ":EQ 4238#"
                                    Outdata = "4254 0 Select#"
                                Case ":EQ 3998#"
                                    Outdata = "3966 4302 Comets#"
                                Case ":EQ 4302#"
                                    Outdata = "4318 0 Select#"
                                Case ":EQ 4318#"
                                    Outdata = "4350 0 Add#"
                                Case ":EQ 4350#"
                                    Outdata = "4334 0 Delete#"
                                Case ":EQ 4334#"
                                    Outdata = "4302 0 Edit#"
                                Case ":EQ 4302#"
                                    Outdata = "4318 0 Select#"
                                Case ":EQ 3966#"
                                    Outdata = "3982 0 Mercury#"
                                Case ":EQ 3934#"
                                    Outdata = "4366 0 Constellations#"
                                Case ":EQ 4366#"
                                    Outdata = "4382 4398 Deep Sky#"
                                Case ":EQ 4398#"
                                    Outdata = "4414 0 Named Objects#"
                                Case ":EQ 4414#"
                                    Outdata = "4446 0 Galaxies#"
                                Case ":EQ 4446#"
                                    Outdata = "4462 0 Nebulas#"
                                Case ":EQ 4462#"
                                    Outdata = "4478 0 Planetary Neb.#"
                                Case ":EQ 4478#"
                                    Outdata = "4494 0 Star Clusters#"
                                Case ":EQ 4494#"
                                    Outdata = "4510 0 Quasars#"
                                Case ":EQ 4510#"
                                    Outdata = "4526 0 Black Holes#"
                                Case ":EQ 4526#"
                                    Outdata = "4542 0 Abell Cluters#"
                                Case ":EQ 4542#"
                                    Outdata = "4558 0 Arp Galaxies#"
                                Case ":EQ 4558#"
                                    Outdata = "4574 0 MCG#"
                                Case ":EQ 4574#"
                                    Outdata = "4590 0 UGC#"
                                Case ":EQ 4590#"
                                    Outdata = "4606 0 Herschel#"
                                Case ":EQ 4606#"
                                    Outdata = "4622 0 IC Objects#"
                                Case ":EQ 4622#"
                                    Outdata = "4638 0 NGC Objects#"
                                Case ":EQ 4638#"
                                    Outdata = "4654 0 Caldwell Objects#"
                                Case ":EQ 4654#"
                                    Outdata = "4430 0 Messier Objects#"
                                Case ":EQ 4430#"
                                    Outdata = "4398 0 Custom Catalogs#"
                                Case ":EQ 4398#"
                                    Outdata = "4414 0 Named Objects#"
                                Case ":EQ 4382#"
                                    Outdata = "4670 4686 Star#"
                                Case ":EQ 4686#"
                                    Outdata = "4702 0 Named#"
                                Case ":EQ 4702#"
                                    Outdata = "4734 0 Hipparcos Cat.#"
                                Case ":EQ 4734#"
                                    Outdata = "4750 0 SAO Catalog#"
                                Case ":EQ 4750#"
                                    Outdata = "4766 0 HD Catalog#"
                                Case ":EQ 4766#"
                                    Outdata = "4782 0 HR Catalog#"
                                Case ":EQ 4782#"
                                    Outdata = "4798 0 Multiple#"
                                Case ":EQ 4798#"
                                    Outdata = "4814 0 GCVS(variables)#"
                                Case ":EQ 4814#"
                                    Outdata = "4718 0 Nearby#"
                                Case ":EQ 4718#"
                                    Outdata = "4686 0 With Planets#"
                                Case ":EQ 4686#"
                                    Outdata = "4702 0 Named#"
                                Case ":EQ 4670#"
                                    Outdata = "4830 4846 Satellites#"
                                Case ":EQ 4846#"
                                    Outdata = "4862 0 Select#"
                                Case ":EQ 4862#"
                                    Outdata = "4894 0 Add#"
                                Case ":EQ 4894#"
                                    Outdata = "4878 0 Delete#"
                                Case ":EQ 4878#"
                                    Outdata = "4846 0 Edit#"
                                Case ":EQ 4846#"
                                    Outdata = "4862 0 Select#"
                                Case ":EQ 4830#"
                                    Outdata = "4910 4926 User Object#"
                                Case ":EQ 4926#"
                                    Outdata = "4942 0 Select#"
                                Case ":EQ 4942#"
                                    Outdata = "4974 0 Add#"
                                Case ":EQ 4974#"
                                    Outdata = "4958 0 Delete#"
                                Case ":EQ 4958#"
                                    Outdata = "4926 0 Edit#"
                                Case ":EQ 4926#"
                                    Outdata = "4942 0 Select#"
                                Case ":EQ 4910#"
                                    Outdata = "4990 5006 Landmarks#"
                                Case ":EQ 5006#"
                                    Outdata = "5022 0 Select#"
                                Case ":EQ 5022#"
                                    Outdata = "5038 0 Add#"
                                Case ":EQ 5038#"
                                    Outdata = "5006 0 Delete#"
                                Case ":EQ 5006#"
                                    Outdata = "5022 0 Select#"
                                Case ":EQ 4990#"
                                    Outdata = "3950 0 Identify#"
                                Case ":EQ 3950#"
                                    Outdata = "3918 5054 Browse#"
                                Case ":EQ 5054#"
                                    Outdata = "5070 0 Start Search#"
                                Case ":EQ 5070#"
                                    Outdata = "5054 0 Edit Parameters#"
                                Case ":EQ 5054#"
                                    Outdata = "5070 0 Start Search#"
                                Case ":EQ 3918#"
                                    Outdata = "3934 3966 Solar System#"
                                Case ":EQ 3886#"
                                    Outdata = "5086 5102 Event#"
                                Case ":EQ 5102#"
                                    Outdata = "5118 0 Sunrise#"
                                Case ":EQ 5118#"
                                    Outdata = "5150 0 Sun's Transit#"
                                Case ":EQ 5150#"
                                    Outdata = "5166 0 Sunset#"
                                Case ":EQ 5166#"
                                    Outdata = "5182 0 Moonrise#"
                                Case ":EQ 5182#"
                                    Outdata = "5198 0 Moon's Transit#"
                                Case ":EQ 5198#"
                                    Outdata = "5214 0 Moonset#"
                                Case ":EQ 5214#"
                                    Outdata = "5230 5246 Moon Phases#"
                                Case ":EQ 5246#"
                                    Outdata = "5262 0 Next Full Moon#"
                                Case ":EQ 5262#"
                                    Outdata = "5294 0 Next New Moon#"
                                Case ":EQ 5294#"
                                    Outdata = "5278 0 Next 1st Qtr #"
                                Case ":EQ 5278#"
                                    Outdata = "5246 0 Next 3rd Qtr #"
                                Case ":EQ 5246#"
                                    Outdata = "5262 0 Next Full Moon#"
                                Case ":EQ 5230#"
                                    Outdata = "5310 0 Meteor Showers#"
                                Case ":EQ 5310#"
                                    Outdata = "5326 0 Solar Eclipses#"
                                Case ":EQ 5326#"
                                    Outdata = "5342 0 Lunar Eclipses#"
                                Case ":EQ 5342#"
                                    Outdata = "5358 0 Min. of Algol#"
                                Case ":EQ 5358#"
                                    Outdata = "5374 0 Autumn Equinox#"
                                Case ":EQ 5374#"
                                    Outdata = "5390 0 Vernal Equinox#"
                                Case ":EQ 5390#"
                                    Outdata = "5134 0 Winter Solstice#"
                                Case ":EQ 5134#"
                                    Outdata = "5102 0 Summer Solstice#"
                                Case ":EQ 5102#"
                                    Outdata = "5118 0 Sunrise#"
                                Case ":EQ 5086#"
                                    Outdata = "5406 0 Guided Tour#"
                                Case ":EQ 5406#"
                                    Outdata = "5422 0 Glossary#"
                                Case ":EQ 5422#"
                                    Outdata = "3902 5438 Utilities#"
                                Case ":EQ 5438#"
                                    Outdata = "5454 0 Ambient Temp.#"
                                Case ":EQ 5454#"
                                    Outdata = "5486 5502 Timer#"
                                Case ":EQ 5502#"
                                    Outdata = "5518 0 Set#"
                                Case ":EQ 5518#"
                                    Outdata = "5502 0 Start/Stop#"
                                Case ":EQ 5502#"
                                    Outdata = "5518 0 Set#"
                                Case ":EQ 5486#"
                                    Outdata = "5534 5550 Alarm#"
                                Case ":EQ 5550#"
                                    Outdata = "5566 0 Set#"
                                Case ":EQ 5566#"
                                    Outdata = "5550 0 On/Off#"
                                Case ":EQ 5550#"
                                    Outdata = "5566 0 Set#"
                                Case ":EQ 5534#"
                                    Outdata = "5582 5598 Eyepiece Calc.#"
                                Case ":EQ 5598#"
                                    Outdata = "5614 0 Field of View#"
                                Case ":EQ 5614#"
                                    Outdata = "5630 0 Magnification#"
                                Case ":EQ 5630#"
                                    Outdata = "5598 0 Suggest#"
                                Case ":EQ 5598#"
                                    Outdata = "5614 0 Field of View#"
                                Case ":EQ 5582#"
                                    Outdata = "5646 0 Brightest Star#"
                                Case ":EQ 5646#"
                                    Outdata = "5662 0 Brightnes Adj.#"
                                Case ":EQ 5662#"
                                    Outdata = "5678 0 Contrast Adj.#"
                                Case ":EQ 5678#"
                                    Outdata = "5694 0 Panel Light#"
                                Case ":EQ 5694#"
                                    Outdata = "5710 0 Aux Port Power#"
                                Case ":EQ 5710#"
                                    Outdata = "5726 0 Beep#"
                                Case ":EQ 5726#"
                                    Outdata = "5742 0 Battery Alarm#"
                                Case ":EQ 5742#"
                                    Outdata = "5758 0 Landmark Survey#"
                                Case ":EQ 5758#"
                                    Outdata = "5470 0 Sleep Scope#"
                                Case ":EQ 5470#"
                                    Outdata = "5438 0 Park Scope#"
                                Case ":EQ 5438#"
                                    Outdata = "5454 0 Ambient Temp.#"
                                Case ":EQ 3902#"
                                    Outdata = "3870 5774 Setup#"
                                Case ":EQ 5774#"
                                    Outdata = "5790 5822 Align#"
                                Case ":EQ 5822#"
                                    Outdata = "5870 0 Easy#"
                                Case ":EQ 5870#"
                                    Outdata = "5886 0 One Star#"
                                Case ":EQ 5886#"
                                    Outdata = "5854 0 Two Star#"
                                Case ":EQ 5854#"
                                    Outdata = "5838 0 Align on Home#"
                                Case ":EQ 5838#"
                                    Outdata = "5822 0 Automatic#"
                                Case ":EQ 5822#"
                                    Outdata = "5870 0 Easy#"
                                Case ":EQ 5790#"
                                    Outdata = "5902 0 Date#"
                                Case ":EQ 5902#"
                                    Outdata = "5918 0 Time#"
                                Case ":EQ 5918#"
                                    Outdata = "5934 0 Daylight Savomgs#"
                                Case ":EQ 5934#"
                                    Outdata = "5950 0 GPS-UTC Offset#"
                                Case ":EQ 5950#"
                                    Outdata = "5966 5982 Telescope#"
                                Case ":EQ 5982#"
                                    Outdata = "5998 0 Mount#"
                                Case ":EQ 5998#"
                                    Outdata = "6030 0 Telescope Model#"
                                Case ":EQ 6030#"
                                    Outdata = "6046 0 Focal Lenght#"
                                Case ":EQ 6046#"
                                    Outdata = "6062 0 Max Slew Rate#"
                                Case ":EQ 6062#"
                                    Outdata = "6078 0 Mnt.Upper Limit#"
                                Case ":EQ 6078#"
                                    Outdata = "6094 0 Mnt.Lower Limit#"
                                Case ":EQ 6094#"
                                    Outdata = "6110 6126 Park Postition#"
                                Case ":EQ 6126#"
                                    Outdata = "6142 0 Use Current#"
                                Case ":EQ 6142#"
                                    Outdata = "6126 0 Use Default#"
                                Case ":EQ 6126#"
                                    Outdata = "6142 0 Use Current#"
                                Case ":EQ 6110#"
                                    Outdata = "6158 0 Calibrate Home#"
                                Case ":EQ 6158#"
                                    Outdata = "6174 6190 Anti-Backlash#"
                                Case ":EQ 6190#"
                                    Outdata = "6206 0 RA/Az. Percent#"
                                Case ":EQ 6206#"
                                    Outdata = "6190 0 Dec/El. Percent#"
                                Case ":EQ 6190#"
                                    Outdata = "6206 0 RA/Az. Pecent#"
                                Case ":EQ 6174#"
                                    Outdata = "6222 6238 Train Drive#"
                                Case ":EQ 6238#"
                                    Outdata = "6254 0 RA Train#"
                                Case ":EQ 6254#"
                                    Outdata = "6238 0 Dec. Train#"
                                Case ":EQ 6238#"
                                    Outdata = "6254 0 RA Train#"
                                Case ":EQ 6222#"
                                    Outdata = "6270 0 Cal. Sensors#"
                                Case ":EQ 6270#"
                                    Outdata = "6286 0 Tracking Rate#"
                                Case ":EQ 6286#"
                                    Outdata = "6302 0 Guiding Rate#"
                                Case ":EQ 6302#"
                                    Outdata = "6318 0 Dec. Guiding#"
                                Case ":EQ 6318#"
                                    Outdata = "6334 0 Reverse L/R#"
                                Case ":EQ 6334#"
                                    Outdata = "6350 0 Reverse UP/DOWN#"
                                Case ":EQ 6350#"
                                    Outdata = "6366 0 Home Sensors#"
                                Case ":EQ 6366#"
                                    Outdata = "6382 0 GPS Alignment#"
                                Case ":EQ 6382#"
                                    Outdata = "6398 6414 RA PEC#"
                                Case ":EQ 6414#"
                                    Outdata = "6430 0 On/Off#"
                                Case ":EQ 6430#"
                                    Outdata = "6462 0 Restore Factory#"
                                Case ":EQ 6462#"
                                    Outdata = "6446 0 Train#"
                                Case ":EQ 6446#"
                                    Outdata = "6414 0 Update#"
                                Case ":EQ 6414#"
                                    Outdata = "6430 0 On/Off#"
                                Case ":EQ 6398#"
                                    Outdata = "6478 6494 Dec PEC#"
                                Case ":EQ 6494#"
                                    Outdata = "6510 0 On/Off#"
                                Case ":EQ 6510#"
                                    Outdata = "6542 0 Restore Factory#"
                                Case ":EQ 6542#"
                                    Outdata = "6526 0 Train#"
                                Case ":EQ 6526#"
                                    Outdata = "6494 0 Update#"
                                Case ":EQ 6494#"
                                    Outdata = "6510 0 On/Off#"
                                Case ":EQ 6478#"
                                    Outdata = "6014 0 Field Derotator#"
                                Case ":EQ 6014#"
                                    Outdata = "5982 0 High Precision#"
                                Case ":EQ 5982#"
                                    Outdata = "5998 0 Mount#"
                                Case ":EQ 5966#"
                                    Outdata = "6558 0 Targets#"
                                Case ":EQ 6558#"
                                    Outdata = "6574 6590 Site#"
                                Case ":EQ 6590#"
                                    Outdata = "6606 0 Select#"
                                Case ":EQ 6606#"
                                    Outdata = "6638 0 Add#"
                                Case ":EQ 6638#"
                                    Outdata = "6622 0 Delete#"
                                Case ":EQ 6622#"
                                    Outdata = "6590 6654 Edit#"
                                Case ":EQ 6654#"
                                    Outdata = "6670 0 Name#"
                                Case ":EQ 6670#"
                                    Outdata = "6702 0 Latitude#"
                                Case ":EQ 6702#"
                                    Outdata = "6686 0 Longitude#"
                                Case ":EQ 6686#"
                                    Outdata = "6654 0 Time Zone#"
                                Case ":EQ 6654#"
                                    Outdata = "6670 0 Name#"
                                Case ":EQ 6590#"
                                    Outdata = "6606 0 Select#"
                                Case ":EQ 6574#"
                                    Outdata = "6718 6734 Smart Mount#"
                                Case ":EQ 6734#"
                                    Outdata = "6750 0 Configuration#"
                                Case ":EQ 6750#"
                                    Outdata = "6782 0 Load#"
                                Case ":EQ 6782#"
                                    Outdata = "6798 0 Save As#"
                                Case ":EQ 6798#"
                                    Outdata = "6766 0 Delete#"
                                Case ":EQ 6766#"
                                    Outdata = "6734 0 Restore Factory#"
                                Case ":EQ 6734#"
                                    Outdata = "6750 0 Configuration#"
                                Case ":EQ 6718#"
                                    Outdata = "6814 6830 Owner Info.#"
                                Case ":EQ 6830#"
                                    Outdata = "6846 0 Name#"
                                Case ":EQ 6846#"
                                    Outdata = "6830 6862 Address#"
                                Case ":EQ 6862#"
                                    Outdata = "6878 0 Street#"
                                Case ":EQ 6878#"
                                    Outdata = "6910 0 City#"
                                Case ":EQ 6910#"
                                    Outdata = "6894 0 State#"
                                Case ":EQ 6894#"
                                    Outdata = "6862 0 Zip Code#"
                                Case ":EQ 6862#"
                                    Outdata = "6878 0 Street#"
                                Case ":EQ 6830#"
                                    Outdata = "6846 0 Name#"
                                Case ":EQ 6814#"
                                    Outdata = "6926 6942 Clone#"
                                Case ":EQ 6942#"
                                    Outdata = "6958 0 Catalogs#"
                                Case ":EQ 6958#"
                                    Outdata = "6974 0 Software#"
                                Case ":EQ 6974#"
                                    Outdata = "6942 0 All#"
                                Case ":EQ 6942#"
                                    Outdata = "6958 0 Catalogs#"
                                Case ":EQ 6926#"
                                    Outdata = "6990 0 Download#"
                                Case ":EQ 6990#"
                                    Outdata = "5806 0 Statistics#"
                                Case ":EQ 5806#"
                                    Outdata = "5774 0 Reset#"
                                Case ":EQ 5774#"
                                    Outdata = "5790 5822 Align#"
                                Case ":EQ 3870#"
                                    Outdata = "3886 3918 Object#"
                                    Autostar_Object = Autostar_Object_Top
                            End Select
                            LX200_Send()
                        End If
                    End If

                    ' Query autostar status
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":ED#" Then
                        Outdata = Autostar_Object
                        If Mid(Autostar_Object, 2, 6) = "Taking" Then
                            Autostar_Object = Autostar_Sim
                        End If
                        LX200_Send()
                    End If

                    ' ES commands (select object)
                    If Mid(LX200_command, Beg, 3) = ":ES" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Autostar_Object = Autostar_Sim
                        End If
                    End If

                    ' EK commands (key presses)
                    If Mid(LX200_command, Beg, 3) = ":EK" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Select Case LX200_command
                                Case ":EK9#"            ' Mode key
                                    Autostar_Object = Autostar_Object_Top
                                Case ":EK13#"           ' Enter key
                                    Autostar_Object = Autostar_Sim
                                Case ":EK 71#"          ' Goto Key
                                    Autostar_Object = " Taking GPS Fix  Slewing...      #"
                            End Select
                        End If
                    End If

                    ' Astro-Physics GTO commands
                    ' Set long format
                    If Microsoft.VisualBasic.Right(LX200_command, 3) = ":U#" Then
                        AP_Long = True
                        CheckBoxAP_Long.Checked = AP_Long
                        LabelAPGTO.Text = AP_GTO_Text
                    End If
                    ' Get servo controller software version
                    If Microsoft.VisualBasic.Right(LX200_command, 3) = ":V#" Then
                        Outdata = UCase(TextBoxGTOCPfirmware.Text) & "#"
                        LX200_Send()
                    End If
                    ' Get side of pier telescope is currently positioned
                    If Microsoft.VisualBasic.Right(LX200_command, 4) = ":pS#" Then
                        AP_Long = True
                        If FormShow.RadioButtonAuto.Checked = True Then
                            GetSideOfPier()
                        Else
                            If FormShow.RadioButtonEast.Checked = True Then
                                AP_SOP = "East"
                            End If
                            If FormShow.RadioButtonWest.Checked = True Then
                                AP_SOP = "West"
                            End If
                        End If
                        LabelAPGTO.Text = AP_GTO_Text
                        Outdata = AP_SOP & "#"
                        LX200_Send()
                    End If
                    ' Sets DEC backlash compensation
                    If Mid(LX200_command, Beg, 3) = ":Bd" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If
                    ' Sets RA backlash compensation
                    If Mid(LX200_command, Beg, 3) = ":Br" Then
                        If Microsoft.VisualBasic.Right(LX200_command, 1) = "#" Then
                            Outdata = "1"
                            LX200_Send()
                        End If
                    End If

                    ' PluseGuide Init commands for Astro-Physics mounts
                    If Mid(LX200_command, Beg, 2) = ":G" Then
                        If Mid(LX200_command, Beg + 2, 1) = Chr(16) Then
                            Outdata = PulseGuide1
                            LX200_command = ":G(16)#"
                            LX200_Send()
                        End If
                        If Mid(LX200_command, Beg + 2, 1) = Chr(4) Then
                            Outdata = PulseGuide2
                            LX200_command = ":G(4)#"
                            LX200_Send()
                        End If
                        If Mid(LX200_command, Beg + 2, 1) = Chr(23) Then
                            Outdata = PulseGuide3
                            LX200_command = ":G(23)#"
                            LX200_Send()
                        End If
                        If Mid(LX200_command, Beg + 2, 1) = Chr(18) Then
                            Outdata = PulseGuide4
                            LX200_command = ":G(18)#"
                            LX200_Send()
                        End If
                        If Mid(LX200_command, Beg + 2, 1) = Chr(5) Then
                            Outdata = PulseGuide5
                            LX200_command = ":G(5)#"
                            LX200_Send()
                        End If
                        If Mid(LX200_command, Beg + 2, 1) = Chr(21) Then
                            Outdata = PulseGuide6
                            LX200_command = ":G(21)#"
                            LX200_Send()
                        End If
                    End If

                End If

                ' Astro-Physics CP4 commands
                ' Get ethernet ip address
                If Microsoft.VisualBasic.Right(LX200_command, 5) = ":ICp#" Then
                    Outdata = CP4ip
                    LX200_Send()
                End If


                ' A response is not sent for this command
                If RespSent = False And LX200_command.Length > 0 Then
                    ListBoxInput.Items.Add(LX200_command)
                    ListBoxInput.SelectedIndex = InCount
                    InCount = InCount + 1
                    GroupBoxInput.Text = InputBoxText & InCount
                    ListBoxOutput.Items.Add("<none>")
                    ListBoxOutput.SelectedIndex = RespCount
                    RespCount = RespCount + 1
                    GroupBoxOutput.Text = OutputBoxText & RespCount
                End If
CMD_Done:
            Next

            ' clear indata after processing
            Indata = PartCmd
            InBufLen = PartCmd.Length

        End If

    End Sub

    Private Sub CheckBoxAGF_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles CheckBoxAGF.Click
        If CheckBoxAGF.Checked = True Then
            LabelAGF.Visible = True
            If CheckBoxML.Checked = True Then
                CheckBoxML.Checked = False
                LabelML.Visible = False
            End If
        Else
            LabelAGF.Visible = False
        End If

    End Sub

    Private Sub CheckBoxML_Click(sender As Object, e As System.EventArgs) Handles CheckBoxML.Click
        If CheckBoxML.Checked = True Then
            LabelML.Visible = True
            If CheckBoxAGF.Checked = True Then
                CheckBoxAGF.Checked = False
                LabelAGF.Visible = False
            End If
        Else
            LabelML.Visible = False
        End If

    End Sub

    Public Sub GetSiderealTime()
        Dim utilities As New ASCOM.Utilities.Util
        Dim LST As Double = 0.0

        SiteLongitude = utilities.DMSToDegrees(LX200_lon)
        If FormShow.CheckBoxLonW.Checked = True Then
            SiteLongitude = SiteLongitude * -1
        End If
        ' now using novas 3.1
        Using novas As New ASCOM.Astrometry.NOVAS.NOVAS31
            Dim jd As Double = utilities.DateUTCToJulian(DateTime.UtcNow)
            novas.SiderealTime(jd, 0, novas.DeltaT(jd),
                               ASCOM.Astrometry.GstType.GreenwichMeanSiderealTime,
                               ASCOM.Astrometry.Method.EquinoxBased,
                               ASCOM.Astrometry.Accuracy.Reduced,
                               LST)
        End Using
        LST += SiteLongitude / 360.0 * 24.0
        LST = LST Mod 24.0
        If LST < 0 Then LST = LST + 24

        ST = LST

        SiderealTime = utilities.DegreesToDMS(LST, ":", ":", "", 1)
        TextBoxFSD.Text = SiderealTime

    End Sub

    Private Sub GetSideOfPier()
        ' calculate side of pier
        Try
            Dim RaH As Integer = Mid(LX200_ra, 1, 2)
            Dim RaM As Integer = Mid(LX200_ra, 4, 2)
            Dim RaS As Integer = Mid(LX200_ra, 7, 4)
            Dim RaSs As Integer = Mid(LX200_ra, 10, 1)
            RA = RaH + (RaM / 60) + (RaS / 3600) + (RaSs / 36000)

            Dim ScopeRA As Double = RaH + (RaM / 60) + (RaS / 3600)

            Dim HA As Double = HAScale(ST - ScopeRA)
            Dim MerDist As Double = HA * 15.0

            If MerDist < 0.0 Then
                AP_SOP = "West"
            Else
                AP_SOP = "East"
            End If

        Catch ex As Exception
            StatusLabel.Text = ex.Message
        End Try

    End Sub

    ' range the azimuth parameter
    Public Function HAScale(ByVal HA As Double) As Double

        While HA < -12
            HA = HA + 24
        End While
        While HA >= 12
            HA = HA - 24
        End While

        HAScale = HA

    End Function

    Private Sub ButtonSTnow_Click(sender As System.Object, e As System.EventArgs) Handles ButtonSTnow.Click
        GetSiderealTime()
        ListBoxInput.Items.Add("Site Longitude")
        ListBoxOutput.Items.Add(Mid(LX200_lon, 1, LX200_lon.Length - 1) & "  (" & Format(SiteLongitude, "00.0000") & ")")
        ListBoxInput.Items.Add("Now Sidereal Time")
        ListBoxOutput.Items.Add(SiderealTime & "   (" & Format(ST, "00.0000") & ")")
        ScrollListBox(2)

    End Sub

    Private Sub UpdateAltAz()
        If CheckBoxAutoAlAz.Checked = True Then
            CalcALTfromRADEC()
            CalcAZfromRADEC()
        End If

    End Sub

    Private Sub UpdateRaDec()
        If CheckBoxAutoAlAz.Checked = True Then
            TransRADECfromALTAZ()
        End If

    End Sub

    Private Sub CalcALTfromRADEC()
        ' This routine calculates Alt from RA, DEC, LATITUDE & SIDEREAL TIME
        Dim RAlen As Integer = 3

        Try
            If LX200_ra.Length < 10 Then
                RAlen = 2
            End If
            RA = Mid(LX200_ra, 1, 2) + Mid(LX200_ra, 4, 2) / 60 + Mid(LX200_ra, 7, RAlen) / 3600
            DEC = Mid(LX200_dec, 2, 2) + Mid(LX200_dec, 5, 2) / 60 + Mid(LX200_dec, 8, 2) / 3600
            If Mid(LX200_dec, 1, 1) = "-" Then
                DEC = DEC * -1
            End If
            LAT = Mid(LX200_lat, 2, 2) + Mid(LX200_lat, 5, 2) / 60 + Mid(LX200_lat, 8, 2) / 3600
            If Mid(LX200_lat, 1, 1) = "-" Then
                LAT = LAT * -1
            End If
            LST = ST

            Dim RAdeg As Double = RA * 15
            Dim LSTdeg As Double = LST * 15
            Dim HA As Double
            HA = LSTdeg - RAdeg

            If HA < 0 Then HA = HA + 360

            Dim x As Double = Math.Cos(HA * (Math.PI / 180)) * Math.Cos(DEC * (Math.PI / 180))
            Dim y As Double = Math.Sin(HA * (Math.PI / 180)) * Math.Cos(DEC * (Math.PI / 180))
            Dim z As Double = Math.Sin(DEC * (Math.PI / 180))

            Dim xhor As Double = x * Math.Cos((90 - LAT) * (Math.PI / 180)) - z * Math.Sin((90 - LAT) * (Math.PI / 180))
            Dim yhor As Double = y
            Dim zhor As Double = x * Math.Sin((90 - LAT) * (Math.PI / 180)) + z * Math.Cos((90 - LAT) * (Math.PI / 180))

            Az = Math.Atan2(yhor, xhor) * (180 / Math.PI) + 180
            Alt = Math.Asin(zhor) * (180 / Math.PI)

            DegToDMS(Alt)
            'Dim Altfmt = DegSign & utl.DegreesToDMS(Alt, "*", ":", "", 0) & "#"
            Dim ALTfmt = DegSign & Format(Deg, "00") & "*" & Format(M, "00") & ":" & Format(S, "00") & "#"
            ListBoxInput.Items.Add("Calc Alt")
            ListBoxOutput.Items.Add(ALTfmt)
            LX200_alt = ALTfmt
            ScrollListBox(1)

        Catch ex As Exception
            StatusLabel.Text = ex.Message

        End Try

    End Sub

    Private Sub CalcAZfromRADEC()
        ' This routine calculates Az from RA, DEC, LATITUDE & SIDEREAL TIME
        Dim Ralen As Integer = 3

        Try
            If LX200_ra.Length < 10 Then
                Ralen = 2
            End If
            RA = Mid(LX200_ra, 1, 2) + Mid(LX200_ra, 4, 2) / 60 + Mid(LX200_ra, 7, Ralen) / 3600
            DEC = Mid(LX200_dec, 2, 2) + Mid(LX200_dec, 5, 2) / 60 + Mid(LX200_dec, 8, 2) / 3600
            If Mid(LX200_dec, 1, 1) = "-" Then
                DEC = DEC * -1
            End If
            LAT = Mid(LX200_lat, 2, 2) + Mid(LX200_lat, 5, 2) / 60 + Mid(LX200_lat, 8, 2) / 3600
            If Mid(LX200_lat, 1, 1) = "-" Then
                LAT = LAT * -1
            End If
            LST = ST

            Dim RAdeg As Double = RA * 15
            Dim LSTdeg As Double = LST * 15
            Dim HA As Double
            HA = LSTdeg - RAdeg

            If HA < 0 Then HA = HA + 360

            Dim x As Double = Math.Cos(HA * (Math.PI / 180)) * Math.Cos(DEC * (Math.PI / 180))
            Dim y As Double = Math.Sin(HA * (Math.PI / 180)) * Math.Cos(DEC * (Math.PI / 180))
            Dim z As Double = Math.Sin(DEC * (Math.PI / 180))

            Dim xhor As Double = x * Math.Cos((90 - LAT) * (Math.PI / 180)) - z * Math.Sin((90 - LAT) * (Math.PI / 180))
            Dim yhor As Double = y
            Dim zhor As Double = x * Math.Sin((90 - LAT) * (Math.PI / 180)) + z * Math.Cos((90 - LAT) * (Math.PI / 180))

            Az = Math.Atan2(yhor, xhor) * (180 / Math.PI) + 180
            Alt = Math.Asin(zhor) * (180 / Math.PI)

            DegToDMS(Az)
            'Dim Azfmt = DegSign & utl.DegreesToDMS(Az, "*", ":", "", 0) & "#"
            Dim AZfmt = DegSign & Format(Deg, "000") & "*" & Format(M, "00") & ":" & Format(S, "00") & "#"
            ListBoxInput.Items.Add("Calc Az")
            ListBoxOutput.Items.Add(AZfmt)
            LX200_az = AZfmt
            ScrollListBox(1)

        Catch ex As Exception
            StatusLabel.Text = ex.Message

        End Try

    End Sub


    Private Sub DegToDMS(ByVal D As Double)
        Deg = Math.Truncate(D)
        If D >= 0.0 Then
            DegSign = "+"
        End If
        If D < 0.0 And D > -1.0 Then
            DegSign = "-"
        End If
        If D <= -1.0 Then
            DegSign = ""
        End If

        M = (D - Deg) * 60.0
        M = Math.Truncate(M)
        S = (D - Deg) * 3600 - (M * 60)
        M = Math.Abs(M)
        S = Math.Abs(S)
        SS = S - Math.Truncate(S)
        SS = SS * 10
        If S > 59 Then S = 59

    End Sub


    Private Sub TransRADECfromALTAZ()
        Dim RAd As Double
        Dim DECd As Double
        Dim nowUTC As DateTime
        Dim transform As New ASCOM.Astrometry.Transform.Transform

        Try
            nowUTC = DateTime.UtcNow

            LAT = Mid(LX200_lat, 2, 2) + Mid(LX200_lat, 5, 2) / 60 + Mid(LX200_lat, 8, 2) / 3600
            If Mid(LX200_lat, 1, 1) = "-" Then
                LAT = LAT * -1
            End If
            If LX200_az.Length < 11 Then
                Az = Mid(LX200_az, 2, 2) + Mid(LX200_az, 5, 2) / 60 + Mid(LX200_az, 8, 2) / 3600
            Else
                Az = Mid(LX200_az, 2, 3) + Mid(LX200_az, 6, 2) / 60 + Mid(LX200_az, 9, 2) / 3600
            End If
            If Mid(LX200_az, 1, 1) = "-" Then
                Az = Az * -1
            End If
            Alt = Mid(LX200_alt, 2, 2) + Mid(LX200_alt, 5, 2) / 60 + Mid(LX200_alt, 8, 2) / 3600
            If Mid(LX200_alt, 1, 1) = "-" Then
                Alt = Alt * -1
            End If

            transform.SiteElevation = 0.0
            transform.SiteLatitude = LAT
            transform.SiteLongitude = SiteLongitude
            transform.JulianDateUTC = utl.DateUTCToJulian(nowUTC)
            transform.SetAzimuthElevation(Az, Alt)

            RAd = transform.RATopocentric
            DECd = transform.DECTopocentric

            Dim RAfmt = utl.DegreesToDMS(RAd, ":", ":", "", 1)
            Dim DECfmt = utl.DegreesToDMS(DECd, "*", ":", "", 0)

            Dim DECsign As String = "+"
            If DECd < 0 Then DECsign = ""

            LX200_ra = RAfmt & "#"
            LX200_dec = DECsign & DECfmt & "#"

            ListBoxInput.Items.Add("Calc RA")
            ListBoxOutput.Items.Add(LX200_ra)
            ListBoxInput.Items.Add("Calc DEC")
            ListBoxOutput.Items.Add(LX200_dec)
            ScrollListBox(2)

        Catch ex As Exception
            StatusLabel.Text = ex.Message

        End Try

    End Sub


    Private Sub LabelCP3_Click(sender As System.Object, e As System.EventArgs) Handles LabelCP3.Click
        TextBoxGTOCPfirmware.Text = "V2"

    End Sub

    Private Sub LabelCP4_Click(sender As System.Object, e As System.EventArgs) Handles LabelCP4.Click
        TextBoxGTOCPfirmware.Text = "VCP4"

    End Sub

End Class
